/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package android.hello;

import java.util.ArrayList;
import java.util.List;

import sparta.checkers.quals.FlowSources;
import sparta.checkers.quals.PolyFlowSinks;
import sparta.checkers.quals.PolyFlowSources;
import sparta.checkers.quals.FlowSources.FlowSource;

/**
 *
 * @author ravi
 */
public  class KMeans {
    public  KMeans()
    {
        setPoints(new ArrayList<Float>());
    }

    private  boolean equallist(List< Integer> prev, List< Integer> clust) {
        assert prev.size()==clust.size();
        for(int i=0;i<prev.size();i++)
        {
            if(prev.get(i)!=clust.get(i))
                return false;
        }
        return true;
    }


    private  Integer mindist( List<Float> means,  Float get) {
        Float min = Float.MAX_VALUE;
        Integer index = -1;
        for(int i=0;i<means.size();i++)
        {
            Float llll=distance(means.get(i),get);
            if(llll<min)
            {
                min=llll;
                index=i;
            }
        }
        return index;
    }
    private  Float distance( Float p1,  Float p2) {
		return Math.abs(p1-p2);
	}
	private @PolyFlowSources @PolyFlowSinks List<Float> points;
	
	@FlowSources(FlowSource.ACCELEROMETER) Float clusterIt()
	{
		return clusterIt(2);
	}
	
	@FlowSources(FlowSource.ACCELEROMETER) Float clusterIt(int k)
    {
        List<Integer> clust = new ArrayList<Integer>();
        int j=0;
        for(int i=0;i<points.size();i++)
        {
            clust.add(j);
            j = (j+1)%k;
        }
        List<Integer> prev = null;
        List<Float> means = new ArrayList<Float>(k);
        for(int i=0;i<k;i++)
        {
            //System.out.println("Now calling Float ka constructor with "+points.get(0).numWords);
        	float f = 0;
            means.add(f);
        }
        //System.out.println("Means ka size is "+means.size());
        int numIter =0;
        while(true)
        {
            //numIter++;
            System.out.println("Iteration number "+ ++numIter);
            prev = new ArrayList<Integer>(clust);
            //System.out.println(prev);
            List<Integer>num = new ArrayList<Integer>();
            means=new ArrayList<Float>();
            for(int i=0;i<k;i++)
            {
                num.add(0);
                float f=0;
                means.add(f);
            }
            int ii = 0;
            for(Float d : points)
            {
                //System.out.println("Means aur clust ka sizes are "+means.size()+" "+clust.size());
                //System.out.println("ii is coming out to be "+ ii);
                means.set(clust.get(ii), means.get(clust.get(ii))+d);
                num.set(clust.get(ii), num.get(clust.get(ii))+1);
                ii++;
            }
            for(int i=0;i<k;i++)
            {
                means.set(i, means.get(i)/num.get(i));
            }

            for(int i=0;i<points.size();i++)
            {
                clust.set(i, mindist(means,points.get(i)));
            }


            if(equallist(prev,clust))
                break;
        }
        Float thresh = (means.get(0)+means.get(1))/2;
        System.out.println("The final clusters are "+ clust);
        System.out.println("Number of iterations needed "+numIter);
        System.out.println("The threshold is "+thresh);
        return thresh;
    }

	/**
	 * @param points the points to set
	 */
	public  @PolyFlowSources @PolyFlowSinks void setPoints(@PolyFlowSources @PolyFlowSinks List<Float> points) {
		this.points = points;
	}


}